;/*******************************/;
;/* Demo Program For RTC DS1202 */;
;/* Hardware  :  ET-CPSB31 V2.0 */;
;/* Complier  :  Cross-32  V2.0 */;
;/*******************************/;
;
;/****************************/;
;/* Equate List Register CPU */;
;/****************************/;
;
P0:         EQU     080H
SP:         EQU     081H
DPL:        EQU     082H
DPH:        EQU     083H
PCON:       EQU     087H
TCON:       EQU     088H
TMOD:       EQU     089H
TL0:        EQU     08AH
TL1:        EQU     08BH
TH0:        EQU     08CH
TH1:        EQU     08DH
P1:         EQU     090H
SCON:       EQU     098H
SBUF:       EQU     099H
P2:         EQU     0A0H
IE:         EQU     0A8H
P3:         EQU     0B0H
IP:         EQU     0B8H
T2CON:      EQU     0C8H
RCAP2L:     EQU     0CAH
RCAP2H:     EQU     0CBH
TL2:        EQU     0CCH
TH2:        EQU     0CDH
PSW:        EQU     0D0H
ACC:        EQU     0E0H
B:          EQU     0F0H
;
P0.0:       EQU     080H
P0.1:       EQU     081H
P0.2:       EQU     082H
P0.3:       EQU     083H
P0.4:       EQU     084H
P0.5:       EQU     085H
P0.6:       EQU     086H
P0.7:       EQU     087H
IT0:        EQU     088H
IE0:        EQU     089H
IT1:        EQU     08AH
IE1:        EQU     08BH
TR0:        EQU     08CH
TF0:        EQU     08DH
TR1:        EQU     08EH
TF1:        EQU     08FH
P1.0:       EQU     090H
P1.1:       EQU     091H
P1.2:       EQU     092H
P1.3:       EQU     093H
P1.4:       EQU     094H
P1.5:       EQU     095H
P1.6:       EQU     096H
P1.7:       EQU     097H
RI:         EQU     098H
TI:         EQU     099H
RB8:        EQU     09AH
TB8:        EQU     09BH
REN:        EQU     09CH
SM2:        EQU     09DH
SM1:        EQU     09EH
SM0:        EQU     09FH
P2.0:       EQU     0A0H
P2.1:       EQU     0A1H
P2.2:       EQU     0A2H
P2.3:       EQU     0A3H
P2.4:       EQU     0A4H
P2.5:       EQU     0A5H
P2.6:       EQU     0A6H
P2.7:       EQU     0A7H
EX0:        EQU     0A8H
ET0:        EQU     0A9H
EX1:        EQU     0AAH
ET1:        EQU     0ABH
ES:         EQU     0ACH
ET2:        EQU     0ADH
EA:         EQU     0AFH
P3.0:       EQU     0B0H
P3.1:       EQU     0B1H
P3.2:       EQU     0B2H
P3.3:       EQU     0B3H
P3.4:       EQU     0B4H
P3.5:       EQU     0B5H
P3.6:       EQU     0B6H
P3.7:       EQU     0B7H
PX0:        EQU     0B8H
PT0:        EQU     0B9H
PX1:        EQU     0BAH
PT1:        EQU     0BBH
PS:         EQU     0BCH
PT2:        EQU     0BDH
T2CP:       EQU     0C8H
T2C:        EQU     0C9H
TR2:        EQU     0CAH
EXEN2:      EQU     0CBH
TLCK:       EQU     0CCH
RCLK:       EQU     0CDH
EXF2:       EQU     0CEH
TF2:        EQU     0CFH
P:          EQU     0D0H
OV:         EQU     0D2H
RS0:        EQU     0D3H
RS1:        EQU     0D4H
F0:         EQU     0D5H
AC:         EQU     0D6H
CY:         EQU     0D7H
ACC.0:      EQU     0E0H
ACC.1:      EQU     0E1H
ACC.2:      EQU     0E2H
ACC.3:      EQU     0E3H
ACC.4:      EQU     0E4H
ACC.5:      EQU     0E5H
ACC.6:      EQU     0E6H
ACC.7:      EQU     0E7H
B.0:        EQU     0F0H
B.1:        EQU     0F1H
B.2:        EQU     0F2H
B.3:        EQU     0F3H
B.4:        EQU     0F4H
B.5:        EQU     0F5H
B.6:        EQU     0F6H
B.7:        EQU     0F7H

;/***************************************/;
;/* Equate List Port I/O ET-CPSB31 V2.0 */;
;/***************************************/;
;
ADC_CS:     EQU     P1.4                ; Chips Select LTC1298
RTC_RESET:  EQU     P1.5                ; Chips Select DS1202
RTC_DATA:   EQU     P1.6                ; Data I/O DS1202
RTC_CLOCK:  EQU     P1.7                ; Clock DS1202
;
SECOND:     EQU     00H                 ; Second 00-59
MINUTE:     EQU     01H                 ; Minute 00-59
HOUR:       EQU     02H                 ; Hour 01-12 or 00-23
DATE:       EQU     03H                 ; Data 01-28/29 or 01-30 or 01-31
MONTH:      EQU     04H                 ; Month 01-12
DAY:        EQU     05H                 ; Day 01-07
YEAR:       EQU     06H                 ; Year 00-99
CTRL_RTC:   EQU     07H                 ; Write Protect Enable/Disable

            CPU     "8051.TBL"
            HOF     "INT8"
            ORG     2200H               ; Strat Program For "ET-DEBUG31"

MAIN:       SETB    RTC_CLOCK           ; Initial Port RTC-DS1202
            SETB    RTC_DATA
            CLR     RTC_RESET
            SETB    ADC_CS              ; Disable CS LTC1298
            ;
INIT_SER:   MOV     A,#0FDH             ; Set baud rate 9600
            MOV     TH1,A
            MOV     TL1,A
            MOV     TMOD,#00100000B     ; Timer1 Mode 1
            MOV     SCON,#01010000B     ; Serial mode 1
            CLR     ES                  ; Disable serial interupt
            CLR     ET1                 ; Disable timer1 interupt
            SETB    TR1                 ; Set timer1 control
            ;
            LCALL   PRINT_SER
            DFB     0CH,"Hardware ET-CPSB31 V2.0",0DH,0AH
            DFB     "Test RTC DS1202",0DH,0AH,0DH,0AH
            DFB     "Hr:Mn:Sec",0DH,0AH,00H
            ;
            LCALL   DISABLE             ; Write Protect OFF
            MOV     A,#SECOND
            LCALL   READ_RTC
            CLR     ACC.7               ; Disable Clock Halt Flag
            MOV     B,A
            MOV     A,#SECOND
            LCALL   WRITE_RTC
            LCALL   ENABLE              ; Write Protect ON
            ;
LOOP:       MOV     A,#HOUR
            LCALL   READ_RTC
            PUSH    ACC
            SWAP    A
            ANL     A,#0FH
            ADD     A,#30H              ; Convert High-Nibble to ASCII
            LCALL   TX_BYTE
            POP     ACC
            ANL     A,#0FH
            ADD     A,#30H              ; Convert Low-Nibble to ASCII
            LCALL   TX_BYTE

            MOV     A,#":"
            LCALL   TX_BYTE

            MOV     A,#MINUTE
            LCALL   READ_RTC
            PUSH    ACC
            SWAP    A
            ANL     A,#0FH
            ADD     A,#30H              ; Convert High-Nibble to ASCII
            LCALL   TX_BYTE
            POP     ACC
            ANL     A,#0FH
            ADD     A,#30H              ; Convert Low-Nibble to ASCII
            LCALL   TX_BYTE

            MOV     A,#":"
            LCALL   TX_BYTE

            MOV     A,#SECOND
            LCALL   READ_RTC
            PUSH    ACC
            SWAP    A
            ANL     A,#0FH
            ADD     A,#30H              ; Convert High-Nibble to ASCII
            LCALL   TX_BYTE
            POP     ACC
            ANL     A,#0FH
            ADD     A,#30H              ; Convert Low-Nibble to ASCII
            LCALL   TX_BYTE

            MOV     A,#0DH
            LCALL   TX_BYTE
            SJMP    LOOP

;/************************************/;
;/*  Print Data data to Serial Port  */;
;/*  to display buffer.              */;
;/*  Usage    : LCALL PRINT_SER      */;
;/*           : DFB  "xxxx",00       */;
;/*  Register : ACC                  */;
;/*  Note     : last byte must be 00 */;
;/************************************/;
;
PRINT_SER:  POP     DPH
            POP     DPL
PRINT1:     CLR     A
            MOVC    A,@A+DPTR
            CJNE    A,#00H,PRINT2
            SJMP    PRINT3
PRINT2:     LCALL   TX_BYTE
            INC     DPTR
            SJMP    PRINT1
PRINT3:     PUSH    DPL
            PUSH    DPH
            RET

;/*************************/;
;/* Send 1-Byte to RS-232 */;
;/* Input   : ACC         */;
;/* Output  : Serial port */;
;/*************************/;
;
TX_BYTE:    PUSH    IE
            CLR     TI
            MOV     SBUF,A
            JNB     TI,$
            CLR     TI
            POP     IE
            RET

;/****************************/;
;/* Read Ram From RTC-DS1202 */;
;/* Input    : ACC = Address */;
;/* Output   : ACC = Data    */;
;/* Reg.     : ACC,B,R2      */;
;/****************************/;
;
READ_RAM:   LCALL   START_RST           ; Start Communication
            MOV     R2,#8
            RL      A                   ; Shift A0 to A1
            SETB    ACC.7               ; Command Status
            SETB    ACC.6               ; Ram Accress
            SETB    ACC.0               ; Read Command
            CLR     CY
READ_RAM1:  LCALL   CLOCK_LO            ; Falling Clock
            RRC     A                   ; Send D0..D7 (Read-Command)
            MOV     RTC_DATA,C          ; Prepare Port
            NOP                         ; Wait Bus Ready
            NOP
            NOP
            NOP
            LCALL   CLOCK_HI            ; Rising Clock
            DJNZ    R2,READ_RAM1        ; Repeat Send Read-Command
            ;
            MOV     B,#0
            MOV     R2,#8
READ_RAM2:  SETB    RTC_DATA            ; Initial for Input
            NOP
            NOP
            LCALL   CLOCK_LO            ; Read data D0..D7 (Data)
            NOP                         ; Wait Data From RTC
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            MOV     C,RTC_DATA          ; Read data out bit
            MOV     A,B
            RRC     A                   ; Read D0..D7
            MOV     B,A                 ; Backup Data
            LCALL   CLOCK_HI            ; Rising Clock
            DJNZ    R2,READ_RAM2
            MOV     A,B                 ; Data Output 1-Byte
            LCALL   STOP_RST            ; Disable Communication
            RET

;/***************************/;
;/* Write Ram to RTC-DS1202 */;
;/* Input   : ACC = Address */;
;/*         : B = Data      */;
;/* Reg.    : ACC,B,R2      */;
;/***************************/;
;
WRITE_RAM:  LCALL   START_RST           ; Enable Communication
            MOV     R2,#8
            RL      A                   ; Shift A0 to A1
            SETB    ACC.7               ; Command Status
            SETB    ACC.6               ; Ram Accress
            CLR     ACC.0               ; Write Command
            CLR     CY
WRITE_RAM1: LCALL   CLOCK_LO            ; Falling Clock
            RRC     A                   ; Send D0..D7 (Write-Command)
            MOV     RTC_DATA,C
            NOP                         ; Wait Bus Ready
            NOP
            NOP
            NOP
            LCALL   CLOCK_HI            ; Rising Clock
            DJNZ    R2,WRITE_RAM1       ; Repeat write Command
            ;
            MOV     A,B                 ; Get Data For Send
            MOV     R2,#8
            CLR     CY
WRITE_RAM2: LCALL   CLOCK_LO            ; Falling Clock
            RRC     A                   ; Write D0..D7
            MOV     RTC_DATA,C
            NOP                         ; Wait Bus Ready
            NOP
            NOP
            NOP
            LCALL   CLOCK_HI
            DJNZ    R2,WRITE_RAM2       ; Repeat write Data
            LCALL   STOP_RST            ; Disable Communication
            RET

;/****************************/;
;/* Read RTC From RTC-DS1202 */;
;/* Input    : ACC = Address */;
;/* Output   : ACC = Data    */;
;/* Reg.     : ACC,B,R2      */;
;/****************************/;
;
READ_RTC:   LCALL   START_RST           ; Start Communication
            MOV     R2,#8
            RL      A                   ; Shift A0 to A1
            SETB    ACC.7               ; Command Status
            CLR     ACC.6               ; Ram Accress
            SETB    ACC.0               ; Read Command
            CLR     CY
READ_RTC1:  LCALL   CLOCK_LO            ; Falling Clock
            RRC     A                   ; Send D0..D7 (Read-Command)
            MOV     RTC_DATA,C          ; Prepare Port
            NOP                         ; Wait Bus Ready
            NOP
            NOP
            NOP
            LCALL   CLOCK_HI            ; Clock
            DJNZ    R2,READ_RTC1        ; Repeat write Command
            ;
            MOV     B,#0
            MOV     R2,#8
READ_RTC2:  SETB    RTC_DATA            ; Initial for Input
            NOP
            NOP
            SETB    RTC_DATA            ; Initial for Input
            LCALL   CLOCK_LO            ; Read data D0..D7 (Data)
            NOP                         ; Wait Data From RTC
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            MOV     C,RTC_DATA          ; Read data out bit
            MOV     A,B
            RRC     A                   ; Read D0..D7
            MOV     B,A                 ; Backup Data
            LCALL   CLOCK_HI            ; Rising Clock
            DJNZ    R2,READ_RTC2
            MOV     A,B                 ; Data Output 1-Byte
            LCALL   STOP_RST            ; Disable Communication
            RET

;/***************************/;
;/* Write RTC to RTC-DS1202 */;
;/* Input   : ACC = Address */;
;/*         : B = Data      */;
;/* Reg.    : ACC,B,R2      */;
;/***************************/;
;
WRITE_RTC:  LCALL   START_RST           ; Enable Communication
            MOV     R2,#8
            RL      A                   ; Shift A0 to A1
            SETB    ACC.7               ; Command Status
            CLR     ACC.6               ; Ram Accress
            CLR     ACC.0               ; Write Command
            CLR     CY
WRITE_RTC1: LCALL   CLOCK_LO            ; Falling Clock
            RRC     A                   ; Write D0..D7 (Command)
            MOV     RTC_DATA,C
            NOP                         ; Wait Bus Ready
            NOP
            NOP
            NOP
            LCALL   CLOCK_HI            ; Rising Clock
            DJNZ    R2,WRITE_RTC1       ; Repeat write Command
            ;
            MOV     A,B                 ; Get Data
            MOV     R2,#8
            CLR     CY
WRITE_RTC2: LCALL   CLOCK_LO
            RRC     A                   ; Write D0..D7
            MOV     RTC_DATA,C
            NOP                         ; Wait Bus Ready
            NOP
            NOP
            NOP
            LCALL   CLOCK_HI            ; Rising Clock
            DJNZ    R2,WRITE_RTC2       ; Repeat write Data
            LCALL   STOP_RST            ; Disable Communication
            RET

;/*************************/;
;/* Write Protect Disable */;
;/* Now You Can Write RTC */;
;/* Reg.    : ACC,B,R2    */;
;/*************************/;
;
DISABLE:    MOV     A,#CTRL_RTC
            MOV     B,#00H              ; Disable Write-Protect
            LCALL   WRITE_RTC
            RET

;/************************/;
;/* Write Protect Enable */;
;/* You Can't Write RTC  */;
;/* Reg.    : ACC,B,R2   */;
;/************************/;
;
ENABLE:     MOV     A,#CTRL_RTC
            MOV     B,#80H              ; Enable Write-Protect
            LCALL   WRITE_RTC
            RET

;/*****************/;
;/*  RTC Clock    */;
;/*  Falling Edge */;
;/*****************/;
;
CLOCK_LO:   CLR     RTC_CLOCK           ; Falling Clock
            NOP
            NOP
            NOP
            NOP
            RET

;/***************/;
;/* RTC Clock   */;
;/* Rising Edge */;
;/***************/;
;
CLOCK_HI:   SETB    RTC_CLOCK           ; Rising Clock
            NOP
            NOP
            NOP
            NOP
            RET

;/*************************/;
;/* Initial Reset & Clock */;
;/* For Start Communicate */;
;/*************************/;
;
START_RST:  CLR     RTC_RESET
            CLR     RTC_CLOCK
            NOP
            NOP
            NOP
            NOP
            SETB    RTC_RESET           ; Enable Communication
            NOP
            NOP
            NOP
            NOP
            RET

;/*************************/;
;/* Initial Reset & Clock */;
;/*  For Stop Communicate */;
;/*************************/;
;
STOP_RST:   SETB    RTC_CLOCK
            NOP
            NOP
            NOP
            NOP
            CLR     RTC_RESET           ; Disable Communication
            NOP
            NOP
            NOP
            NOP
            RET

            END

